/*  Name: Yinyi Guo 
 *  Section Leader: Ben Phillips
 *
 *  EvalInfixExp.cpp
 *  EvalInfixExp
 *
 *  Created by Hugo Guo on 2/4/09.
 *  Copyright 2009 Stanford University. All rights reserved.
 *
 */

#include "EvalInfixExp.h"
#include "scanner.h"
#include <iostream>
#include <string>
#include "simpio.h"
#include "genlib.h"
#include "strutils.h"  

bool isJump(string next,string l, Scanner scanner)    // This function is returning if the order of computation is legal
{
	string last = scanner.nextToken();
	string mid = scanner.nextToken();
	if (mid=="+"||mid=="-") {		  // make sure "*"and "/" first, then "+"and "-"
		if (next=="*"||next=="/")
			return true;
	}
	while (scanner.hasMoreTokens()) {       //  handle with computation order among"()","*/"and "+-"
		string now = scanner.nextToken();
			if (last==")") {
				if (mid=="*"||mid=="/")
					if (l==")")
						return false;
					else 
						return true;
				if(mid=="+"||mid=="-")
					return true;
			}
	last=mid;
	mid =now;
	}
	return false;
}

int EvalInfixExpHelper(string str, Scanner& scanner)
{
	Scanner scannerL;
	string next;
	while (scanner.hasMoreTokens()) {
		str += next;
		next = scanner.nextToken();
		scannerL.setInput(str);              
		if (next=="+") {           // we seperate a big expression into two smaller ones, and do recurssion respectively
			if (!isJump(next,str.substr(str.size()-1, 1),scanner)) 
				return EvalInfixExpHelper("", scannerL)+EvalInfixExpHelper("",scanner);  // there 4 different binary operators
		}                                                                // each of the recursion is doing only after make sure its order is legal
		if (next=="-") {
			if (!isJump(next,str.substr(str.size()-1, 1),scanner)) 
				return EvalInfixExpHelper("",scannerL)-EvalInfixExpHelper("",scanner);
		}
		if (next=="*") {
			if (!isJump(next,str.substr(str.size()-1, 1),scanner)) 
				return EvalInfixExpHelper("",scannerL)*EvalInfixExpHelper("",scanner);
		}
		if (next=="/") {
			if (!isJump(next,str.substr(str.size()-1, 1),scanner))
				return EvalInfixExpHelper("",scannerL)/EvalInfixExpHelper("",scanner);
		}
	}
	if (next!=")") {                        // base case 
		int out = StringToInteger(next);
		return out;
	}
	for (int i=str.size();i>0;i--) {        
		if (str[i-1]!=')')
			return StringToInteger(str.substr(0,i));
	}
	return 0;
}

int EvalInfixExp(string expString)
{
	Scanner scanner;                  // first use a scanner 
	scanner.setInput(expString);     // put the expression string into the scanner 
	scanner.setSpaceOption(Scanner::IgnoreSpaces);   // remove all the spaces 
	int answer = EvalInfixExpHelper("", scanner);
	return answer;
}

int main ()
{
	while (true) {
		cout<<"Give the expression:";
		string exp = GetLine();
		if (exp.size()< 1)
			break;
		cout<<"The answer is: "<< EvalInfixExp(exp)<<endl; 
	}
	return 0;
}